<?php

/*
Badges Plugin for MyBB
Copyright (C) 2017 Iso
*/

if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook('postbit', 'postbit_badges');

function badges_info()
{
         global $lang;
         $lang->load("config_badges");
	 return array(
		"name"	                => $lang->badge,
		"description"		=> $lang->badge_desc,
		"website"		=>	"",
		"author"		=>	"Iso",
		"authorsite"	        => 	"",
		"codename"		=>	"iso_staffbadge",
		"version"		=>	"1.0",
		"compatibility"	=>	"18*"
	);
	
}

function badges_install()
{

       global $db, $mybb, $lang;
       $lang->load("config_badges");
   

	$query_add = $db->simple_select("settinggroups", "COUNT(*) as rows");
	$rows = $db->fetch_field($query_add, "rows");
        $badges_group = array(
		"name" 			=>	"badges_settings",
		"title" 		=> $db->escape_string($lang->setting_group_badge),
		"description" 	        => $db->escape_string($lang->setting_group_badge_desc),
		"disporder"		=> 	$rows+1,
		"isdefault" 	        =>      0
	);
        $db->insert_query("settinggroups", $badges_group);
	$gid = $db->insert_id();
	
	$badges_1 = array(
                 "name"			=> "badges_enable",
                 "title"		=> $db->escape_string($lang->setting_badge_onoff),
                 "description"   	=> $db->escape_string($lang->setting_badge_onoff_desc),
                 "optionscode"  	=> "yesno",
                 "value"                => "0",
                 "disporder"		=> 1,
                 "gid" 			=> (int)$gid
       );
	$db->insert_query("settings", $badges_1);
	
      $badges_2 = array(
		"name"			=> "badges_auto",
		"title"			=> $db->escape_string($lang->setting_badge_auto),
		"description" 	        => $db->escape_string($lang->setting_badge_auto_desc),
                "optionscode"	        => "yesno",
		"value"			=> "0",
		"disporder"		=> 2,
		"gid" 			=> (int)$gid
	);
	
        $db->insert_query("settings", $badges_2);

       $badges_3 = array(
		"name"			=> "badges_link",
		"title"			=> $db->escape_string($lang->setting_badge_link),
		"description" 	        => $db->escape_string($lang->setting_badge_link_desc),
		"optionscode"  	        => "yesno",
                "value"          	=> "0",
		"disporder"		=> 3,
		"gid" 			=> (int)$gid
	);
	$db->insert_query("settings", $badges_3);


	$badges_4 = array(
		"name"			=> "badges_groups",
		"title"			=> $db->escape_string($lang->setting_badge_groups),
		"description" 	        => $db->escape_string($lang->setting_badge_groups_desc),
                "optionscode"	        => "groupselect",
		"value"			=> "",
		"disporder"		=> 4,
		"gid" 			=> (int)$gid
	);
	
        $db->insert_query("settings", $badges_4);
 

        $badges_5 = array(
		"name"			=> "badges_forums",
		"title"			=> $db->escape_string($lang->setting_badge_forums),
		"description" 	        => $db->escape_string($lang->setting_badge_forums_desc),
                "optionscode"  	        => "forumselect",
                "value"        	        => "",
		"disporder"		=> 5,
		"gid" 			=> (int)$gid
	);
	$db->insert_query("settings", $badges_5);

       $badges_6 = array(
                 "name"			=> "badges_mode",
                 "title"		=> $db->escape_string($lang->setting_badge_mode),
                 "description"   	=> $db->escape_string($lang->setting_badge_mode_desc),
                 "optionscode"  	=> "radio \n1=Pre-Made \n2=CSS Element \n3=Custom Image",
                 "value"                => "1",
                 "disporder"		=> 6,
                 "gid" 			=> (int)$gid
       );
	$db->insert_query("settings", $badges_6);

       $badges_7 = array(
		"name"			=> "badges_type",
		"title"			=> $db->escape_string($lang->setting_badge_type),
		"description" 	        => $db->escape_string($lang->setting_badge_type_desc),
                "optionscode"    	=> "select \n1=1 \n2=2 \n3=3 \n4=4 \n5=5",
                "value"          	=> "1",
		"disporder"		=> 7,
		"gid" 			=> (int)$gid
	);
	$db->insert_query("settings", $badges_7);

       $badges_8 = array(
		"name"			=> "badges_image",
		"title"			=> $db->escape_string($lang->setting_badge_image),
		"description" 	        => $db->escape_string($lang->setting_badge_image_desc),
		"optionscode"   	=> "text",
		"value"         	=> "",
		"disporder"		=> 8,
		"gid" 			=> (int)$gid
	);
	$db->insert_query("settings", $badges_8);

	rebuild_settings();

       require_once MYBB_ADMIN_DIR."inc/functions_themes.php";

       $style = @file_get_contents(MYBB_ROOT.'images/badge/badge.css');
        
       $stylesheet = array(
		"name"         		=> "badge.css",
		"cachefile"		=> "badge.css",
		"tid"         		=> "1",
		"attachedto"     	=> "showthread.php",
		"stylesheet"   	        => $db->escape_string($style),
		"lastmodified" 	        => TIME_NOW
	);

	$db->insert_query("themestylesheets", $stylesheet);
	cache_stylesheet(1, "badge.css", $style);
	update_theme_stylesheet_list(1, false, true);

}

function badges_uninstall()
{
       global $db, $mybb;	
	
	$result = $db->simple_select('settinggroups', 'gid', "name = 'badges_settings'", array('limit' => 1));
	$group = $db->fetch_array($result);
	
	if(!empty($group['gid']))
	{
		$db->delete_query('settinggroups', "gid='{$group['gid']}'");
		$db->delete_query('settings', "gid='{$group['gid']}'");
		rebuild_settings();
	}
	
       $db->delete_query("themestylesheets", "name= \"badge.css\"");

       require_once MYBB_ADMIN_DIR."inc/functions_themes.php";
    
       $query = $db->simple_select("themes", "tid");
       while($theme = $db->fetch_array($query))
       {
        @unlink(MYBB_ROOT."cache/themes/theme{$theme['tid']}/badge.css");
        @unlink(MYBB_ROOT."cache/themes/theme{$theme['tid']}/badge.min.css");
        update_theme_stylesheet_list($theme['tid'], false, true); 
       } 
}


function badges_is_installed()
{
    global $mybb, $db;
	
	$installed = $db->query("SELECT * FROM " . TABLE_PREFIX . "settinggroups WHERE `name` = 'badges_settings'");
	if($db->num_rows($installed) == 1)
	{
		return true;
	}
	return false;
} 



function badges_activate()
{
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("postbit", "#".preg_quote('<div class="post_head">')."#i", "<div class=\"post_head\">\n{\$post['badge']}");
	find_replace_templatesets("postbit_classic", "#".preg_quote('<div class="post_head">')."#i", "<div class=\"post_head\">\n{\$post['badge']}");     
}

function badges_deactivate()
{
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("postbit", "#".preg_quote('{$post[\'badge\']}')."(\r?)\n#", '', 0);
	find_replace_templatesets("postbit_classic", "#".preg_quote('{$post[\'badge\']}')."(\r?)\n#", '', 0);
}

function postbit_badges(&$post)
{
	global $settings;	
        $post['badge'] = "";
	if ($settings['badges_enable'] != 0) 
	{  if((in_array($post['usergroup'], explode(",",$settings['badges_groups'])) || $settings['badges_groups'] == -1) && (in_array($post['fid'], explode(",",$settings['badges_forums'])) || $settings['badges_forums'] == -1))
            {
                   if ($settings['badges_mode'] == 1)
                   {
                   if($settings['badges_link'] != 0){
                   $badges = "<div class=\"badge_container\"><a href=\"".$settings['bburl']."/showteam.php\"><img class=\"badge_image\" src=\"".$settings['bburl']."/images/badge/badge_".$settings['badges_type'].".png\" alt=\"Staff\" /></a></div>";
                                                       }
                                                      else{
                   $badges = "<div class=\"badge_container\"><img class=\"badge_image\" src=\"".$settings['bburl']."/images/badge/badge_".$settings['badges_type'].".png\" alt=\"Staff\" /></div>";
                                                       }
                   }
                   else if ($settings['badges_mode'] == 2) 
	           {  
                   if($settings['badges_link'] != 0){
		   $badges = "<div class=\"badge_container\"><a href=\"".$settings['bburl']."/showteam.php\"><div class=\"badge_css\" title=\"Staff\"><span>Staff</span></div></a></div>";				        }
                                                      else{
                   $badges = "<div class=\"badge_container\"><div class=\"badge_css\" title=\"Staff\"><span>Staff</span></div></div>";	
                                                        }
                    }
                   else if ($settings['badges_mode'] == 3) 
                   {
                   $badgesimage = $settings['badges_image'];
                   if (@getimagesize($badgesimage))  
                   {   
                   list($width, $height, $type, $width_height) = getimagesize($badgesimage);  
                   if($settings['badges_link'] != 0){
		   $badges = "<div class=\"badge_container\"><a href=\"".$settings['bburl']."/showteam.php\"><img class=\"badge_image\" ".$width_height." src=\"".$badgesimage."\" alt=\"Staff\" /></a></div>";
			                            }
                                                      else{
                   $badges = "<div class=\"badge_container\"><img class=\"badge_image\" ".$width_height." src=\"".$badgesimage."\" alt=\"Staff\" /></div>";	
                                                        }
                    }
                    }
             }

            if ($settings['badges_auto'] != 0) {
              if (is_moderator($post['fid'], "", $post['uid']))
             {
  
                  if ($settings['badges_mode'] == 1)
                   {
                         if($settings['badges_link'] != 0){
                   $badges = "<div class=\"badge_container\"><a href=\"".$settings['bburl']."/showteam.php\"><img class=\"badge_image\" src=\"".$settings['bburl']."/images/badge/badge_".$settings['badges_type'].".png\" alt=\"Staff\" /></a></div>";
                                                       }
                                                      else{
                   $badges = "<div class=\"badge_container\"><img class=\"badge_image\" src=\"".$settings['bburl']."/images/badge/badge_".$settings['badges_type'].".png\" alt=\"Staff\" /></div>";
                                                       }
                   }
                   else if ($settings['badges_mode'] == 2) 
	           {  
                        if($settings['badges_link'] != 0){
		   $badges = "<div class=\"badge_container\"><a href=\"".$settings['bburl']."/showteam.php\"><div class=\"badge_css\" title=\"Staff\"><span>Staff</span></div></a></div>";				        }
                                                      else{
                   $badges = "<div class=\"badge_container\"><div class=\"badge_css\" title=\"Staff\"><span>Staff</span></div></div>";	
                                                        }
                    }
                   else if ($settings['badges_mode'] == 3) 
                   {
                   $badgesimage = $settings['badges_image'];
                       if (@getimagesize($badgesimage))  
                          {   
                   list($width, $height, $type, $width_height) = getimagesize($badgesimage);  
                         if($settings['badges_link'] != 0){
		   $badges = "<div class=\"badge_container\"><a href=\"".$settings['bburl']."/showteam.php\"><img class=\"badge_image\" ".$width_height." src=\"".$badgesimage."\" alt=\"Staff\" /></a></div>";
			                            }
                                                      else{
                   $badges = "<div class=\"badge_container\"><img class=\"badge_image\" ".$width_height." src=\"".$badgesimage."\" alt=\"Staff\" /></div>";	
                                                        }
                           }
                    }

             }}
       $post['badge'] = $badges;
       }
}
